

"""
Exceptions that may happen in all the webdriver code.
"""

class WebDriverException(Exception):
    """
    Base webdriver exception.
    """

    def __init__(self, msg=None, screen=None, stacktrace=None):
        self.msg = msg
        self.screen = screen
        self.stacktrace = stacktrace

    def __str__(self):
        exception_msg = "Message: %s\n" % self.msg
        if self.screen is not None:
            exception_msg += "Screenshot: available via screen\n"
        if self.stacktrace is not None:
            stacktrace = "\n".join(self.stacktrace)
            exception_msg += "Stacktrace:\n%s" % stacktrace
        return exception_msg


class  VersionError(Exception):
    # 版本号获取异常
    def __init__(self, errorinfor):
        self.error = errorinfor

    def __str__(self):
        return self.error


class AbnormalLogException(Exception):
    """
    日志模块异常base类
    """

    def __init__(self, msg=None):
        self.msg = msg


    def __str__(self):
        exception_msg = "Message: %s\n" % self.msg
        return exception_msg

class LanguageException(Exception):
    """
    语言不支持
    """

    def __init__(self, msg=None):
        self.msg = msg


    def __str__(self):
        exception_msg = "Message: %s\n" % self.msg
        return exception_msg


#
# if 1 == 1 :
#     raise AbnormalLogException("666")
#



# class UnexpectedAlertPresentException(WebDriverException):
#     """
#     Thrown when an unexpected alert is appeared.
#
#     Usually raised when when an expected modal is blocking webdriver form executing any
#     more commands.
#     """
#     def __init__(self, msg=None, screen=None, stacktrace=None, alert_text=None):
#         super(UnexpectedAlertPresentException, self).__init__(msg, screen, stacktrace)
#         self.alert_text = alert_text
#
#     def __str__(self):
#         return "Alert Text: %s\n%s" % (self.alert_text, super(UnexpectedAlertPresentException, self).__str__())
#
#
#
#







