#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/4/26

import base64
import json
import os
from uuid import uuid4

from tank.core.logs import TankLog
# from setting import BASE, PROJECT_URL, TEST_IMG_FILE_PATH, TEST_REPORT_IMG_CASE_FILE_PATH, TEST_RUN_ENV
# from core.fileOs import getListFiles
# from core.interface_redis import TankRedis
# from core.excel_io import TankOpenExecl


log4j = TankLog()
var = ""


import random


def getID(index=8):
    """
    用于生成随机字符串
    :param index:
    :return:
    """
    id = ''

    var = '0123456789zxcvbnmasdfghjklqwertyuiopPOIUYTREWQASDFGHJKLMNBVCXZ'

    for i in range(index):
        name = random.choice(var)
        id = name+id

    return id

def b64file(imgPath):
    """
    用于对图片进行编码为base64、并进行保存到指定的文件中
    :param imgPath: 图片路径
    :param filePath: 文件路径
    :return:
    """

    with open(imgPath,"rb") as f:#转为二进制格式
        file = imgPath.split('\\')[-1].split('.')
        base64_data = base64.b64encode(f.read())#使用base64进行加密
        fileSaveFile = os.path.join(os.path.join(os.path.join(BASE,"data/baseinfo"),"%s.txt"%file[0])).replace("\\","/")
        file=open(fileSaveFile,'wt')
        #写成文本格式
        file.write(base64_data.decode())
        file.close()


# def refilenames(path,file_name):
#     """
#     批量进行修改文件名称
#     :param path:
#     :return:
#     """
#     data = getListFiles(path)
#     con = 0
#
#     for i in data:
#         unx = i.replace('\\','/')
#         file = unx.split('/')
#         save = file[-1].split('.')
#         file[-1] = "hccr_%s_%s.%s"%(file_name,con,save[-1])
#         pj = "\\".replace('\\','/').join(file)
#         os.renames(i,pj)
#         con += 1
#     return 1

# def redisBase64(key,path,texts):
#     """
#     将图片的base64编码进行存储到redis中
#     :param key:
#     :param path:
#     :param texts:
#     :return:
#     """
#     data = getListFiles(path)
#     count = 1
#     for s in data:
#         unx = s.replace('\\','/')
#         file = unx.split('/')[-1]
#         filename = file.split('.')[0]
#         base64_data = None
#
#         with open(s, "rb") as f:  # 转为二进制格式
#             base64_data = base64.b64encode(f.read())  # 使用base64进行加密
#             f.close()
#         text = {"%s"%filename:"{\"id\":\"%s\",\"code\":\"%s\",\"title\":\"%s_%s_%s\"}"%(filename,base64_data.decode("utf-8"),filename,texts,count)}
#
#         tank = TankRedis()
#         tank.connect().hmset(key,text)
#         count += 1

def redisTables(path):
    """
    用于存储图片的标注文字存储到redis中
    :param path:
    :return:
    """
    with open(path, "r", encoding="utf-8") as f:
        text_line = f.readlines()
        for text in text_line:
            base = text.split(" ")
            print(base[-1].replace('\n',''))
        # print(text_line)


def get_base64_var(file):
    """
    用于进行读取指定的base64字符的文件内容
    :param file:
    :return:
    """
    log4j.info("正在读取路径>>%s的文件内容"%file)
    try:
        with open(os.path.join(os.path.join(os.path.join(BASE,"data/baseInfo"),file),).replace("\\","/"),'r') as f:
            readFile_var = f.readline()
            f.close()
            return readFile_var
    except Exception as e:
        log4j.error(e)

# def base64all(path):
#     """
#     批量进行将指定文件夹下的图片进行base64编码并进行存储到指定的文件中
#     :param path:
#     :return:
#     """
#     data = getListFiles(path)
#     for i in data:
#         b64file(i)
#     return 1
#

def b64Savefile(imgPath):
    """
    进行图片文件进行base64编码
    :param imgPath: 图片路径
    :param filePath: 文件路径
    :return:
    """
    log4j.info("正在进行对%s编码操作" % imgPath)
    try:
        with open(imgPath,"rb") as f:#转为二进制格式

            file = imgPath.split('\\')[-1].split('.')
            base64_data = base64.b64encode(f.read())#使用base64进行加密

            fileSaveFile = os.path.join(os.path.join(os.path.join(BASE,"data/baseinfo"),"%s.txt"%file[0])).replace("\\","/")
            file = open(fileSaveFile,'wt',encoding='utf-8')

            #写成文本格式
            file.write(base64_data.decode())
            file.close()
    except Exception as  e:
        log4j.error(e)


class JsonBase64:
    def __init__(self,path):
        self.path = path
        # self.get_path_subfile(path)


    def get_path_subfile(self):
        """
        获取指定目录下的所有子文件
        :param path:
        :return:
        """

        listsubfile = []
        for r, x, d in os.walk(self.path):
            for path in d:
                listsubfile.append([r,path])
        return listsubfile

    def get_sub_dir(self):
        """
        获取指定目录下的子文件夹
        :return:
        """
        listdir = []
        for r, x, d in os.walk(self.path):
            for path in x:
                listdir.append([r,path])
        return listdir


    def json_base64(self):
        """json"""
        json_base64 = []
        subfile = self.get_path_subfile()
        for file in subfile:
            joinfile = "\\".join(file)
            filename = joinfile.split('\\')[-1].split('.')[0]
            with open(joinfile, "rb") as f:  # 转为二进制格式
                base64_data = base64.b64encode(f.read())  # 使用base64进行加密
                f.close()

            json_base64.append({f"{filename}":f"{base64_data.decode()}"})

        with open(r"F:\interfaceTestng\data\lables\lables.json","w+") as f:
            json.dump(json_base64,f)


    def get_json_base64(self):
        json_data = []
        with open(r"F:\interfaceTestng\data\lables\lables.json","w+") as f:
            text = json.load(f)
            print(text)

def add_json_label_file(path):

    result = []
    with open(path,"r",encoding="utf-8") as f:
        list_text = f.readlines()
        f.close()

    for s in list_text:
        string = s.split(" ")
        if len(string) >= 2:

            result.append({"%s"%string[0]:"%s"%string[1].strip('\n')})

    with open("F:\interfaceTestng\data\labels\lables.json","w+") as f:
        text = json.dump(result,f,ensure_ascii=True)

    return result



def get_label_file_json(path):


    with open("F:\interfaceTestng\data\labels\lables.json","r") as f:
        text = json.load(f)

    return text




def get_label_file(path):

    result = []
    with open(path,"r",encoding="utf-8") as f:
        list_text = f.readlines()
        f.close()

    for s in list_text:
        string = s.split(" ")
        if len(string) >= 2:
            result.append([string[0],string[1].strip('\n')])

    return result



#
#
#
# class BaseHttpRequest:
#     """
#     用于发送请求封装
#     """
#
#     def __init__(self,url=None):
#         self.request_url =None
#         self.request_path = None
#         log4j.info("当前测试环境为:%s" % TEST_RUN_ENV)
#
#         # TEST_RUN_ENV
#         #TODO: 0520 修改 guanfl
#         if TEST_RUN_ENV == "sit" and url is None:
#
#             self.request_url = PROJECT_URL["hccr"]["sit"]["host"]
#
#         elif TEST_RUN_ENV == 'uat' and url is None:
#             self.request_url = PROJECT_URL["hccr"]["uat"]["host"]
#
#         elif TEST_RUN_ENV == "prod" and url is None:
#             self.request_url = PROJECT_URL["hccr"]["prod"]["host"]
#
#         else:
#             self.request_url = url
#
#         log4j.info("当前环境请求地址为:%s" % self.request_url)
#
#
#
#     def get(self,path,data=None):
#         """
#         发送get请求
#         :param path:
#         :param data:
#         :return:
#         """
#         # https://jideapi.ai.jideos.com/
#         self.url = self.request_url+path
#         log4j.info("当前的请求url为:%s" % self.url)
#         self.req = requests.get(url=self.url,params=data)
#         log4j.info("当前的响应url为:%s" % self.req.url)
#         _data = json.loads(self.req.content)
#         # log4j.info("当前的响应body为:%s" % self.req.content)
#         log4j.info("当前的响应状态码为:%s" % self.req.status_code)
#         return _data,self.req.status_code
#
#     def post(self,id,path=None,data=None,headers=None,label_path=None):
#
#         # 将传入的data 数据进行序列化
#         if data:
#             # log4j.info("请求body:%s" % data)
#             json_data = json.dumps(data)
#             log4j.info("原请求body类型为:%s,当前格式转换:%s" %(type(data),type(json_data)))
#         else:
#             json_data = 0
#
#         # 如果有传入headers 就使用传入的headers值没有就使用默认的headers值
#         if headers is not None:
#             self.header = headers
#
#         else:
#             self.header = {"Content-Type":"application/json"}
#
#         if path is not None: #当传入了url参数时就使用传入的url
#             self.url = self.request_url + path
#
#         else:
#             self.url = self.request_url +  PROJECT_URL["hccr"]["sit"]["host"]
#         print("===================>",self.url)
#
#         log4j.info("当前的请求url为:%s" % self.url)
#
#         self.req = requests.post(url= self.request_url, data=json_data,headers=self.header)
#         _response = self.req.content.decode("utf-8") #获响应后的响应体内容
#
#         log4j.info("当前的请求header为:%s" % self.header)
#
#         # 对响应体进行反序列化 转化成dict
#         try:
#             #如果响应体出现非json数据格式会进行报错、因此需要进行捕捉异常
#             dict_response = json.loads(_response)
#
#
#         except:
#             # 如果不是json类型数据则进行将请求结果直接进行变量保存
#             dict_response = _response
#
#         # 进行判断dict_response 参数类型是否为dict
#         if isinstance(dict_response,dict) is True:
#
#             try:
#                 if dict_response["Data"]:
#
#                     dict_json = json.loads(dict_response["Data"])
#                     content_line = 1
#                     content_set = []
#                     if dict_json["message"]:
#
#                         content_set.append({"id": id, "text":None,"message": "没有识别到文字"})
#                         # with open(os.path.join(TEST_REPORT_IMG_CASE_FILE_PATH,datetime.datetime.now().strftime("%Y-%m-%d %H:%M") + "_case" + ".txt"),"w+") as f:
#                         #     f.write(id)
#                         #     f.close()
#                     else:
#
#                         for text in dict_json["data"]["list"]:
#                             dump_text = text["text"]
#
#                             content_set.append({"id": id, "line": content_line, "text": dump_text})
#
#                             content_line += 1
#
#                     log4j.info("当前的响应url为:%s" % self.req.url)
#
#                     log4j.info("当前的响应图片识别结果为:%s" % content_set)
#
#                     try:
#
#                         _data = json.loads(self.req.content)
#                     except:
#                         _data = self.req.content
#
#
#                     test_result = [id]
#
#                     if label_path:
#
#
#                         label_path = label_path
#                     else:
#
#                         label_path = "F:\interfaceTestng\data\labels\label_freenote_zh.txt"
#
#                     di = DiffLibPush()
#                     if  test_result is not None and len(test_result) >= 1:
#
#                         for s in content_set:
#                             # with open("")
#                             log4j.info(msg="当前为文本第%s行" %s["line"])
#
#                             txt = get_label_file(label_path)
#
#
#                             for x in txt:
#                                 if x[0] == id:
#                                     print("=========没有异常===============>\n", 123)
#                                     self.df = di.diff_matcher_format(s["text"],x[-1])
#                                     self.pd = di.diff_matcher_ratio(s["text"],x[-1])
#
#                             # 将识别的内容有差异的结果进行添加到test_result中
#                             if self.df != 0:
#                                 test_result.append(
#                                     [str(s["enline3"]),"识别结果：",s["text"],"期望结果：",x[1],"识别精度：",str( self.pd)]
#                                 )
#
#                         text = id
#                         now = datetime.datetime.now().strftime("%Y-%m-%d_%H")
#                         for texts in  test_result:
#                             # print(texts)
#
#                             if isinstance(texts,list) is True:
#                                 text = "  ".join(texts)
#
#                             case = os.path.join(TEST_REPORT_IMG_CASE_FILE_PATH,"character/%s_case_result.txt"%now).replace("\\","/")
#
#                             with open(case,"a+",encoding="utf-8") as f:
#                                 f.write(text+"\n")
#                                 f.close()
#
#
#
#                         log4j.info("当前的响应状态码为:%s" % self.req.status_code)
#
#
#                     return _data,self.req.status_code,content_set
#
#             except:
#                 data = json.loads(self.req.content)
#
#                 return  data,self.req.status_code
#
#
#
#         #
#
#     def freenote_post(self,id,path=None,data=None,headers=None,label_path=None):
#
#         if path:
#             self.path = path
#
#         else:
#             self.path = PROJECT_URL["freenote"]["sit"]["url"]+"/"+PROJECT_URL["freenote"]["sit"]["path"]
#
#         # 将传入的data 数据进行序列化
#         if data:
#             json_data = json.dumps(data)
#             log4j.info("原请求body类型为:%s,当前格式转换:%s" %(type(data),type(json_data)))
#         else:
#             json_data = 0
#         #
#         # 如果有传入headers 就使用传入的headers值没有就使用默认的headers值
#         if headers is not None:
#             self.header = headers
#         else:
#
#             self.header = {"Content-Type":"application/json"}
#
#
#         self.req = requests.post(url=self.path, data=json_data,headers=self.header)
#
#         _response = self.req.content.decode("utf-8") #获响应后的响应体内容
#         log4j.info("当前的请求header为:%s" % self.header)
#
#         # 对响应体进行反序列化 转化成dict
#         try:
#             #如果响应体出现非json数据格式会进行报错、因此需要进行捕捉异常
#             dict_response = json.loads(_response)
#
#         except:
#             # 如果不是json类型数据则进行将请求结果直接进行变量保存
#             dict_response = _response
#
#         content_set = []
#
#         if isinstance(dict_response, dict) is True:
#             try:
#                 if dict_response["data"]:
#                     result =  dict_response["data"]["result"]
#                     content_set.append({"id": id, "text": result[0]})
#             except Exception as e:
#                 pass
#
#         log4j.info("当前的响应url为:%s" % self.req.url)
#
#         log4j.info("当前的响应图片识别结果为:%s" % content_set)
#
#         if label_path:
#
#             label_path = label_path
#         else:
#             label_path = "F:\interfaceTestng\data\labels\label_freenote_zh.txt"
#
#         test_result = [id]
#
#         if  test_result is not None and len(test_result) >= 1:
#
#             for s in content_set:
#                 txt = get_label_file(label_path)
#                 di = DiffLibPush()
#
#                 for x in txt:
#                     if x[0] == id:
#                         self.df = di.diff_matcher_format(s["text"],x[-1])
#                         self.pd = di.diff_matcher_ratio(s["text"],x[-1])
#
#
#                 # 将识别的内容有差异的结果进行添加到test_result中
#                 try:
#                     if self.df != 0:
#                         test_result.append(
#                             [str(s["id"]),"识别结果：",s["text"],"期望结果：",x[1],"识别精度：",str( self.pd)]
#                         )
#                 except Exception as e:
#                     log4j.error(msg="%s\n%s"%(e,s))
#                     print(e,s)
#
#
#             text = id
#             now = datetime.datetime.now().strftime("%Y-%m-%d_%H")
#             for texts in  test_result:
#
#                 if isinstance(texts,list) is True:
#                     text = "  ".join(texts)
#
#                 case = os.path.join(TEST_REPORT_IMG_CASE_FILE_PATH,"character/%s_case_result.txt"%now).replace("\\","/")
#                 try:
#                     with open(case,"a+",encoding="utf-8") as f:
#                         f.write(text+"\n")
#                         f.close()
#                 except Exception as e:
#                     log4j.error(msg=e)
#
#                 log4j.info("当前的响应状态码为:%s" % self.req.status_code)
#
#
#
#
#         return self.req.status_code,dict_response
#
#




def is_dir(path):
    """
    判断是否为文件夹
    :param path:
    :return:
    """
    p = os.path.splitext(path)
    if p[0]:
        return True
    else:
        return False


import difflib


# TODO : 文本检查结果
class DiffLibPush:
    def __init__(self):
        pass

    def diff_context(self,a,b):
        """

        :param a:
        :param b:
        :return:
        """

        return difflib.context_diff(a, b)


    def diff_matcher_ratio(self,str1, str2):
        """比较差异的精度比例"""
        return difflib.SequenceMatcher(None, str1, str2).quick_ratio()


    def diff_matcher(self,str1, str2):
        """比较差异的精度比例"""
        return difflib.SequenceMatcher(None, str1, str2).get_opcodes()


    def diff_matcher_format(self,reality, expect):
        """格式化对比
            equal:相同
            replace:被取代
            (tag, i1, i2, j1, j2)，其中tag表示动作，i1表示序列a的开始位置，i2表示序列a的结束位置，j1表示序列b的开始位置，j2表示序列b的结束位置。
            reality:实际 expect 预期
        """
        log4j.info(msg="实际文本内容为: %s,期望文本内容为: %s"%(reality,expect))
        diff_text_replace = ''
        result = []
        _diff =  difflib.SequenceMatcher(None, reality, expect).get_opcodes()
        text_cum = 0 #记录的是哪些存在差异的字符串数
        for tag,i1,i2,j1,j2 in _diff:
            if tag != "equal":
                log4j.info(msg="%s 实际文本结果:[%s]__期望文本结果:[%s][%d:%d]_[%s] obj2:[%s:%s]_[%s]" \
                                    ""%(tag,reality,expect,i1,i2,reality[i1:i2],j1,j2,expect[j1:j2]))
                # diff_text_replace = "%s 实际文本结果:[%s]__期望文本结果:[%s][%d:%d]_[%s] obj2:[%s:%s]_[%s]" \
                #                     ""%(tag,reality,expect,i1,i2,reality[i1:i2],j1,j2,expect[j1:j2])
                if i1 - i2 != 0 or j1 -j2 != 0:
                    result.append(reality[i1:i2]) # 将实际文本中的字符与期望字符中不存在的字符进行保存到result列表中
                    result.append(expect[j1:j2]) # 将期望文本中的字符与实际字符中不存在的字符进行保存到result列表中
                    text_cum += 1


        # text_cum 为0证明文本没有出现差异字符 其他均为有存在差异字符
        if text_cum == 0:
            log4j.info(msg="本次检测识别结果未发现存在差异字符")
            return 0
        else:
            log4j.info(msg="本次检测识别出%s个字符存在差异"%len("".join(result)))
            log4j.info(msg="差异字符为 %s"%"".join(result))
        return result




class Auth:


    def __init__(self):
        pass

    def uid_hex(self,string):
        return string + uuid4().hex

#
# class RequestCaseRun(BaseHttpRequest):
#     def __init__(self):
#         super(RequestCaseRun, self).__init__()
#         self.code = None
#         self.env = None
#
#     def run(self,data,headers=None):
#        return self.post(path=PROJECT_URL["SIT"]["path"], data=data,headers=headers)
#
#     def send_post(self,id,data,headers=None):
#         # 发送http请求
#         _resp = self.post(path=PROJECT_URL["SIT"]["path"],data=data,headers=headers,id=id)
#         #
#         _response = _resp[0]["Data"]
#         _json = json.loads(_response)
#         data_json = _json["data"]["list"]
#         content_line = 1
#         content_set = []
#         for text in data_json:
#             dump_text = text["text"]
#
#             content_set.append({"id":id,"line":content_line,"text":dump_text})
#
#             content_line+=1
#         return content_set
#

#
# def data_init():
#     #数据初始化
#     t = TankRedis()
#     t.fl()
#
#     for r,x,d in os.walk(TEST_IMG_FILE_PATH):
#         """
#         rootdir:当前目录路径、subdir当前目录下的所有子目录名称、当前目录下的文件
#                 # (rootdir,subdir,current_file)
#         """
#         _d = str(r)
#
#         # if is_dir(r) is  True or is_dir(s):
#         dirname = _d.split('\\')[-1]
#
#         table = [["enline2", "二行纯英文手写识别测试集"], ["enline1", "一行纯英文手写识别测试集"],["enline3", "三行纯英文手写识别测试集"],
#                  ["enline4", "四行纯英文手写识别测试集"],["entext", "纯英文文本手写识别测试集"],["zhline1", "一行中文文本手写识别测试集"],
#                  ["zhline2", "二行中文文本手写识别测试集"],["zhline6", "一行中文文本手写识别测试集"],["zh","随手写中文用例集"],["en","随手写英文用例集"]]
#         for t in table:
#             if t[0] == dirname:
#                 print(dirname)
#                 redisBase64(key=str(t[0]), path=r, texts=t[1])
#     return 1
#
#
# def relables(path,tabpath):
#     data = getListFiles(path)
#     text_save = []
#     for i in data:
#         unx = i.replace('\\', '/')
#         file = unx.split('/')
#         save = file[-1].split('.')
#
#         text_line = None
#
#             # print(text)
#
#         # ex = TankOpenExecl(TEST_CASE_FILE_PATH)
#         # ex.update()
#         file[-1] = "hccr_%s_%s.%s" % (getID(), file[-2], save[-1])
#         # text[0] = 1
#         pj = "\\".replace('\\', '/').join(file)
#         os.renames(i, pj)
#
#         with open(tabpath, "r", encoding="utf-8") as f:
#             text_line = f.readlines()
#
#         for s in text_line:
#             text = s.split(" ")
#             print(save[0],text[0])
#             if save[0] == text[0]:
#                 text[0] = save[0]
#                 text_save.append({"filename":text[0],"text":text[-1]})
#
#     return 1
#
#
#
#




# https://test.ai.jideos.com/jideai/hccr/cv/recognition
if __name__ == '__main__':
    pass

    # j = JsonBase64(path=r'F:\interfaceTestng\data\img')
    # print(j.get_json_base64())
    #
    # str1 = "11i4"
    # str2 = "14"
    # print(diff_matcher_format(str1, str2))

    # print(get_label_file(r"F:\interfaceTestng\data\labels\line1.txt"))
    #


    # print(refilenames(path=r'F:\interfaceTestng\data\img\zh\zhline2',file_name="zhline2"))
    # print(data_init())

    # print()

    # def get_dir(path=r'F:\interfaceTestng\data\img\en'):
    #     for r,s,c in os.walk(path):
    #         # (rootdir,subdir,current_file)
    #         """
    #         rootdir:当前目录路径、subdir当前目录下的所有子目录名称、当前目录下的文件
    #         """
    #
    #         print(r,s,c)
    #
    # get_dir()


    # # print(name)
    # a = "中文\n"
    # b = "中文"
    # d = diff_matcher_format(a, b)
    # print(base64all(path=r'F:\interface\testng\data\img'))
    # print(redisBase64(path=r'F:\interface\testng\data\img'))

    # print(base64all(path=r'F:\interface\testng\data\img'))

    # t = TankRedis()
    # t.fl()
    # redisBase64("line2",r"F:\interface\testng\data\img\line2")
    # text = t.connect().hget(name="zhline1",key="hccr_0qRfCycN_line01")
    # print(text)
    # du = json.loads(text)
    # print(type(du))
    # print(t.connect().hget("enline2", "hccr_enline2_5"))


    # for value in t.connect().hkeys("enline1"):
    #     # print(s)
    #     val = t.connect().hget("enline1",value)
    #     d = json.loads(val)
    #     r = BaseHttpRequest()
    #     # r = RequestCaseRun()
    #     data = {
    #         "Key": "092a0c68163447c7b8a6a547db5e3988cd956a65af824a278e8ab57fcdfc63f7",
    #         "Nonce": 3,
    #         "Data": d["code"]
    #     }
    #     # name = r.run(data=data)
    #     r.post(url="https://ai.jideos.com/jideai/hccr/cv/recognition",data=data,id=value)
    #





