#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/5/20
import io
import os
import shutil
import sys
import zipfile


# v 1.0
# guanfl
# 2021.5.28
# :TODO 已完成 待单元测试
class TkOS:
    def __init__(self):
        pass


    def get_path_list(self,path):
        """
        指定目录下的所有文件路径
        :param path:
        :return:
        """

        assert os.path.isdir(path), '%s not exist.' % path
        ret = []
        for root, dirs, files in os.walk(path):
            for filespath in files:
                ret.append(os.path.join(root, filespath))
        return ret

    def copy_all(self,src_path, target_path):
        # print(f"========{src_path}",os.path.isdir(src_path),os.path.isdir(target_path))
        # 将某文件夹整体复制至指定文件夹
        if os.path.isdir(src_path) and os.path.isdir(target_path):
            filelist_src = os.listdir(src_path)
            for file in filelist_src:
                path = os.path.join(os.path.abspath(src_path), file)
                if os.path.isdir(path):
                    path1 = os.path.join(os.path.abspath(target_path), file)
                    if not os.path.exists(path1):
                        os.mkdir(path1)
                    self.copy_all(path, path1)
                else:
                    with open(path, 'rb') as read_stream:
                        contents = read_stream.read()
                        path1 = os.path.join(target_path, file)
                        with open(path1, 'wb') as write_stream:
                            write_stream.write(contents)
            return True
        else:
            return False

    def dir_copy(self,src_path, target_path):
        """copy
        all
        files
        of
        src_path
        to
        target_path"""
        # 将某文件夹下所有文件复制至指定文件夹内，但不复制该文件夹的结构
        file_count = 0
        source_path = os.path.abspath(src_path)
        target_path = os.path.abspath(target_path)
        if not os.path.exists(target_path):
            os.makedirs(target_path)
        if os.path.exists(source_path):
            for root, dirs, files in os.walk(source_path):
                for file in files:
                    src_file = os.path.join(root, file)
                    shutil.copy(src_file, target_path)
                    file_count += 1
                    print(src_file)
        return int(file_count)

    def isdir(self,path):
        p = os.path.splitext(path)
        if p[1]:
            return False
        else:
            return True

    def isfile(self,path):
        p = os.path.splitext(path)
        if p[-1]:
            if not os.listdir(path):
                return False
            else:
                return True
        else:
            return False

    def is_listdir(self,path):
        file_list = os.listdir(path)
        file = []
        dir = []
        other_files = []
        listfile = {
            "file": file,
            "dir": dir,
            "other_files": other_files
        }
        for i in file_list:
            p = os.path.splitext(i)
            if p[-1]:
                if p[-1] == ".zip" or p[-1] == ".rar":
                    other_files.append(i)
                    print("{} 目录下 {} 压缩文件".format(path, i))
                else:
                    file.append(i)
                    print("{} 目录下 {} 是文件".format(path, i))
            else:
                dir.append(i)
                print("{} 目录下 {} 是文件夹".format(path, i))
        return listfile

    def del_type_file(self,path, filename):
        pathfile = os.listdir(path)
        for files in pathfile:
            join_file_path = os.path.join(path, files)
            where = os.path.splitext(files)

            if where[-1] == filename:

                os.remove(join_file_path)
                print("已删除{}".format(files))



    def del_all_file(self,path):
        pathfile = os.listdir(path)
        for files in pathfile:
            join_file_path = os.path.join(path, files)
            if os.path.isfile(join_file_path):
                os.remove(join_file_path)
                print("已删除{}".format(files))
            else:
                try:
                    self.del_all_file(join_file_path)
                    os.rmdir(join_file_path)
                    print("已删除{}".format(files))
                except:
                    self.del_all_file(join_file_path)
                print("已删除{}".format(files))

    def del_current_file(self,path):
        pathfile = os.listdir(path)
        for files in pathfile:
            join_file_path = os.path.join(path, files)
            if os.path.isfile(join_file_path) == True:
                os.remove(join_file_path)
                print("已删除{}".format(files))



class ZipFile:
    def __init__(self):
        self.pathFile = None
        self._filer = []

    def all_path(self, path):
        # 递归获取目录下所有文件
        join = os.listdir(path)

        for d in join:
            die = os.path.join(path, d)
            try:
                self.all_path(die)
                self._filer.append(die)
            except:
                self._filer.append(die)
        return self._filer

    def zip_file(self,path, zipfile_name):
        """
        Args:
            path:传入一个需要压缩的文件夹路径
            zipfile_name:压缩包的存放路径
        return:
            传出的是一个压缩包的存放路径
        """
        # 压缩zip文件 path压缩的文件夹路径 压缩文件路径+.zip
        path = path
        join = os.listdir(path)
        join_path = []

        for i in join:
            public = os.path.join(path, i)
            join_path.append(public)

        f = zipfile.ZipFile(zipfile_name, 'w', zipfile.ZIP_DEFLATED)

        for s in join_path:
            jie = s.replace("\\", "/").split('/')
            index = jie[-1]
            f.write(s.replace("\\", "/"), index)

        f.close()

        return zipfile_name

    def all_zip(self, zipfile_name, path):
        _path = self.all_path(path)
        f = zipfile.ZipFile(zipfile_name, 'w', zipfile.ZIP_DEFLATED)
        for adb in _path:
            f.write(adb)

        f.close()
        return _path


    def extract(self,filename):
        z = zipfile.ZipFile(filename)
        for f in z.namelist():
            # get directory name from file
            dirname = os.path.splitext(f)[0]
            # create new directory
            os.mkdir(dirname)
            # read inner zip file into bytes buffer
            content = io.BytesIO(z.read(f))
            zip_file = zipfile.ZipFile(content)
            for i in zip_file.namelist():
                zip_file.extract(i, dirname)



class FileHandle:
    """
    文件操作
    """


    def link(self,path,oj):
        """
         用于创建硬连接的源地址
         用于创建硬连接的目标地址
        :param path:
        :param oj:
        :return:
        """
        try:
            os.link(path,oj)
            return 0
        except:
            return 1

    def isfile(self,file):
        """
        是否存在该文件
        :return:
        """
        return os.path.exists(file)





# v1.2.2
# 20210723
from PIL import Image

import subprocess


class PDFObject:

    def __init__(self,path=None):
        self.path = path
        # 获取当前文件的父级目录名称
        self.BASE_DIR = os.path.dirname(os.path.dirname((os.path.abspath(__file__))))
        self.PDFTOPPMPATH = os.path.join(self.BASE_DIR, 'default/conf/tanktools/bin/pdfImg.exe').replace('\\', '/')


    def _rea(self,path, pdf_name):
        """
        目前仅支持 jpg、png、jpeg格式图片
        :param path:
        :param pdf_name:
        :return:
        """
        file_list = os.listdir(path)
        pic_name = []
        im_list = []
        for x in file_list:
            if "jpg" in x or 'png' in x or 'jpeg' in x:
                pic_name.append(x)

            pic_name.sort()
            new_pic = []

            for x in pic_name:
                if "jpg" in x:
                    new_pic.append(x)

            for x in pic_name:
                if "png" in x:
                    new_pic.append(x)


            im1 = Image.open(os.path.join(path, new_pic[0]))

            new_pic.pop(0)
            for i in new_pic:

                img = Image.open(os.path.join(path, i))
                if img.mode == "RGBA":
                    img = img.convert('RGB')
                    im_list.append(img)
                else:
                    im_list.append(img)
            im1.save(pdf_name, "PDF", resolution=100.0, save_all=True, append_images=im_list)

    def save(self,filepath):
        if ".pdf" in filepath:
            self._rea(self.path, pdf_name=filepath)
            print("pdf已生成完成")
        else:
            self._rea(self.path, pdf_name="{}.pdf".format(filepath))
            print("pdf已生成完成")

    def png(self,pdf_file,path):


        p = subprocess.Popen('"%s" -png "%s" "%s"\math_hw' % (self.PDFTOPPMPATH, pdf_file,path)).communicate()[0]


    def jpeg(self,pdf_file,path):



        p = subprocess.Popen('"%s" -jpeg "%s" "%s"\math_hw' % (self.PDFTOPPMPATH, pdf_file,path)).communicate()[0]

    def tiff(self,pdf_file,path):



        p = subprocess.Popen('"%s" -tiff "%s" "%s"\math_hw' % (self.PDFTOPPMPATH, pdf_file,path)).communicate()[0]


    def svg(self,pdf_file,path):


        p = subprocess.Popen('"%s" -svg "%s" "%s"\math_hw' % (self.PDFTOPPMPATH, pdf_file,path)).communicate()[0]


class TXTObject:

    def __init__(self):
        """
        ::= 4
        """
        # 获取当前文件的父级目录名称
        self.BASE_DIR = os.path.dirname(os.path.dirname((os.path.abspath(__file__))))
        self.PDFTOTEXT = os.path.join(self.BASE_DIR, 'default/conf/poppler/bin/pdftotext.exe').replace('\\', '/')

    def txt(self,pdf_file,path,filename=None):



        # -raw 保留字符顺序流
        # layout 按照布局进行输出文本内容
        # htmlmeta 生成简单的html

        p = subprocess.Popen('"%s" -htmlmeta1 "%s" "%s"\math_hw.txt' % (self.PDFTOTEXT, pdf_file, path)).communicate()[0]

