#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/6/2


import os
import smtplib
import sys
from email.mime.text import MIMEText
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.application import MIMEApplication

from tank.core.logs import TankLog

log4j = TankLog()




class Mail:
    def sender(self,sender,password,toaddrs,title,content=None):
        log4j.info("正在发送自动邮件...")

        try:
            self.sender = sender

            self.password = password

            self.toaddrs = toaddrs

            self.content = content

            self.textApart = MIMEText(self.content)
            self.m = MIMEMultipart()
            # 加上这个qq邮箱不会退邮箱
            self.m['Subject'] = title
            self.m['from'] = sender
            # 用于列表元素切割
            self.m['to'] = ",".join(self.toaddrs)
            self.m.attach(MIMEText(self.content, 'plain', 'utf-8'))

        except Exception:
            log4j.error("邮件配置信息有误请重新修改邮件配置后再重试发送邮件操作")

    def html(self,path,filename):
        filepath = path
        htmlApart = MIMEImage(open(filepath, 'rb').read(), filepath.split('.')[-1])
        htmlApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(htmlApart)

        return htmlApart
    def universalFile(self,path,filename):
        pdfFile = path
        pdfApart = MIMEApplication(open(pdfFile, 'rb').read())
        pdfApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(pdfApart)

    def smtp(self,smtp='smtp.163.com'):
        try:
            server = smtplib.SMTP(smtp)
            server.login(self.sender, self.password)
            server.sendmail(self.sender, self.toaddrs, self.m.as_string())
            log4j.info("邮件已发送成功")
            server.quit()
        except smtplib.SMTPException as e:
            log4j.info(e)

class UnittestMail:
    def __init__(self,sender,password,toaddrs,title,htmlPATH,FILEname,content=None):
        try:
            log4j.info("本次邮件发送人用户名：%s，密码：******"%sender)
            log4j.info("本次邮件接收人用户名：%s"%toaddrs)
            e = Mail()
            e.sender(sender=sender,password=password,toaddrs=toaddrs,title=title,content=content)
            log4j.info("邮件主题为%s"%title)
            e.universalFile(htmlPATH,FILEname)
            log4j.info("邮件正文为%s" % content)
            log4j.info("邮件附件路径%s" % htmlPATH)
            e.smtp()
        except Exception as e:
            log4j.error("请往框架配置文件中修改邮件配置信息,error -- %s"%e)


if __name__ == '__main__':
    fp = r'F:\interfaceTest\report\__init__.py'
    UnittestMail(sender="gfl13453001@161.com", password="gfl802300",
                 toaddrs=["guanfl@jideos.com"],
                 title="手写识别自动化测试报告", htmlPATH=fp, FILEname="测试报告", content="测试一下")



# "qinhaihua@analytechsolution.com","matailu@analytechsolution.com",
