#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/6/4


from selenium import webdriver
from selenium.webdriver.support import expected_conditions as exp
from selenium.webdriver.common.by import By
from selenium.webdriver.support.wait import WebDriverWait



import os, datetime

from src.tank.core.webui.sume import WEBDRIVER_ELEMENT


class BasePage:
    """Page 封装的是公共类 所有测试类都基于该基类"""
    # Page encapsulates a common class. All test classes are based on that base class.
    def __init__(self,driver="chrome",path=None,timeout=10):
        """
        :param driver:
        :param timeout:
        :param path:


        """
        # 加启动配置
        option = webdriver.ChromeOptions()
        option.add_argument('disable-infobars')

        # if CHROME_OPTIONS == True:
        #     self.driver = self.ChromeDriver()
        #
        if driver == "chrome":
            self.driver = webdriver.Chrome(options=option)
        elif driver == "ie":
            self.driver = webdriver.Ie()


        self.url =  "http://www.baidu.com"
        #全局元素定位等待
        self.driver.implicitly_wait(time_to_wait=timeout)

        self.open(path)


    def option(self):
        option = webdriver.ChromeOptions()
        option.add_argument('disable-infobars')
        return option

    # def ChromeDriver(self):
    #
    #     try:
    #
    #         if CHROME_OPTIONS == True:
    #             return webdriver.Chrome(chrome_options=self.option())
    #
    #         else:
    #             return webdriver.Chrome()
    #
    #     except Exception:
    #         return webdriver.Chrome()

    def open(self,path=None):
        if path == None:
            url = None
        else:
            url = path
        if url != None:
            return self.driver.get(url)


    def quit(self):
        return self.driver.quit()






# Map PageElement constructor arguments to webdriver locator enums
LOCATOR_LIST = {
    # selenium
    'css': By.CSS_SELECTOR,
    'id_': By.ID,
    'name': By.NAME,
    'xpath': By.XPATH,
    'link_text': By.LINK_TEXT,
    'partial_link_text': By.PARTIAL_LINK_TEXT,
    'tag': By.TAG_NAME,
    'class_name': By.CLASS_NAME,

    # appium
    # 'ios_uiautomation': MobileBy.IOS_UIAUTOMATION,
    # 'ios_predicate': MobileBy.IOS_PREDICATE,
    # 'ios_class_chain': MobileBy.IOS_CLASS_CHAIN,
    # 'android_uiautomator': MobileBy.ANDROID_UIAUTOMATOR,
    # 'android_viewtag': MobileBy.ANDROID_VIEWTAG,
    # 'android_datamatcher': MobileBy.ANDROID_DATA_MATCHER,
    # 'accessibility_id': MobileBy.ACCESSIBILITY_ID,
    # 'image': MobileBy.IMAGE,
    # 'custom': MobileBy.CUSTOM,
}


class pageElement(BasePage):


    def element(self,by,ele):
        return self.driver.find_element(by=by,value=ele)




    def input_element(self,By,element,value,describe=None):
        """
        :param driver:
        :param By:
        :param element:
        :param valuse:
        :param describe:
        :return:
        """
        describe = describe
        bys = By
        if By == By:
            return self.webWait(by=(WEBDRIVER_ELEMENT[By],element)).send_keys(value)



    def webWait(self,by, timeout=5, pall=0.5):
        """
        driver 浏览器实例对象
        timeout 等待的实际时间
        poll 刷新间隔
        :return:
        """
        try:
            element = WebDriverWait(self.driver, timeout, pall).until(
                # 直到被定位的元素被找到
                exp.presence_of_element_located(by)
            )
            return element
        except:
            print("元素定位失败,你可以尝试修改下 %s" % str(by))



    def button_element(self,By,element,describe=None):
        desctibe = describe
        if By == By:
            return self.webWait(by=(WEBDRIVER_ELEMENT[By],element)).click()


    def shot_save(self,path):
        try:
            sr = datetime.datetime.now().strftime("%Y-%m-%d %H-%M-%S")
            pr = path + '\\' + sr + '.png'
            self.driver.save_screenshot(pr)
            print('截图成功！！！')
        except Exception:
            print('截图失败！！！')

    def handles(self):
        n = self.driver.window_handles
        return n


    def CurrentHandle(self):
        return self.driver.current_window_handle

#
    def switch_windows(self,index):
        return self.driver.switch_to.window(index)


    def scrollTo(self,top,bottom):
        js = "window.scrollTo(%s,%s);"%(top,bottom)
        return self.driver.execute_script(js)



    #
#     def switch_frame(driver, name):
#         driver.switch_to.frame(name)
#
#     def iframe(driver, element):
#         try:
#             iframe = driver.find_element_by_xpath(element)
#             driver.switch_to.iframe(iframe)
#             return iframe
#
#
#         except:
#             print("你的元素定位可能出现了一点小意外,你可以尝试修改下 > %s" % element)
#
#
# from .ObjectPageElement import BasePage
# from selenium.webdriver.common.action_chains import ActionChains
# #鼠标操作模块
# from selenium.webdriver.common.keys import Keys
# from selenium.webdriver.support.ui import Select
#
#
# class page(BasePage):
#
#     def max_window(self):
#         return self.driver.maximize_window()
#
#     def size_window(self,x,y):
#         return self.driver.set_window_size(x,y)
#
#     def context_click(self,xpath=None):
#         right = self.driver.find_element_by_xpath(xpath)
#         # 对定位到的元素执行鼠标右键操作
#         return ActionChains(self.driver).context_click(right).perform()
#
#     def double_click(self,xpath=None):
#
#         # 定位到要双击的元素
#         double = self.driver.find_element_by_xpath(xpath)
#         # 对定位到的元素执行鼠标双击操作
#         return ActionChains(self.driver).double_click(double).perform()
#
#     def drag_and_drop(self,x_name=None,y_name=None):
#         element = self.driver.find_element_by_name(x_name)
#         # 定位元素的原位置
#         target = self.driver.find_element_by_name(y_name)
#         # 定位元素要移动到的目标位置
#         return ActionChains(self.driver).drag_and_drop(element, target).perform()
#         # 执行元素的移动操作
#
#     def shear_input(self,id=None):
#         return self.driver.find_element_by_id(id).send_keys(Keys.CONTROL, 'x')
#
#     def re_enter_content(self,id=None):
#         return self.driver.find_element_by_id(id).send_keys(Keys.CONTROL,'v')
#
#     def wait(self,timeout=5):
#         self.driver.implicitly_wait(timeout)
#
#     @property
#     def source_html(self):
#         """
#         获取当前html源码
#         :return:
#         """
#         p = self.driver.page_source
#         return p
#     @property
#     def title(self):
#         p = self.driver.title
#         return p
#
#     @property
#     def current_url(self):
#         p = self.driver.current
#         return p
#
#
#
# class select_from(object):
#     def __init__(self,xpath):
#         self.sc = Select(xpath)
#
#     def select_by_index(self,index=0):
#         """
#         select = Select(sele_obj)
#         #根据下标选值
#         select.select_by_index(2)
#         #根据value属性选值
#         select.select_by_value("rtf")
#         #根据文本内容选值
#         select.select_by_visible_text("Adobe Acrobat PDF (.pdf)")
#         :return:
#         """
#         self.sc.select_by_index(index)
#
#     def select_by_value(self,value=0):
#         self.sc.deselect_by_value(value)
#
#     def select_by_visible_text(self,text):
#         self.sc.select_by_visible_text(text)
#
#
