#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/6/17
from selenium.webdriver.common.keys import Keys

from src.tank.core.webui.base import pageElement
from src.tank.core.webui.sume import (Keys_Home,Keys_Back_Space,Keys_Space,Keys_Tab,Keys_Escape,Keys_Enter,
                                      Keys_Ctrl_A,Keys_Ctrl_C,Keys_Ctrl_X,Keys_Ctrl_V)
class WebKeys(pageElement):


    # def __init__(self):
    #     super(WebKeys,self).__init__(self)

    F1 = Keys.F1
    F2 = Keys.F2
    F3 = Keys.F3
    F4 = Keys.F4
    F5 = Keys.F5
    F6 = Keys.F6
    F7 = Keys.F7
    F8 = Keys.F8
    F9 = Keys.F9
    F10 = Keys.F10
    F11 = Keys.F11
    F12 = Keys.F12


    def home(self,by,val):
        """
        :param by:
        :param val:
        :return:
        """
        return self.element(by=by,ele=val).send_keys(Keys_Home)

    def text_del(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Back_Space)

    def space(self,by,val,press=1):
        if press != 1:
            return self.element(by=by,ele=val).send_keys(Keys_Space * press)
            # return [self.element(by=by,ele=val).send_keys(Keys_Space) for x in range(press)]

        return self.element(by=by,ele=val).send_keys(Keys_Space)

    def tab(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Tab)

    def esc(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Escape)

    def enter(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Enter)

    def cla(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Ctrl_A)

    def cp(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Ctrl_C)

    def skr(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Ctrl_X)

    def ske(self,by,val):
        return self.element(by=by,ele=val).send_keys(Keys_Ctrl_V)

    def func(self,f,by=None,val=None):
        return self.element(by=by, ele=val).send_keys(f)




class JSElement(object):
    def __init__(self,driver):
        self.driver = driver

    def click(self,class_name=None,id=None,name=None,
                     index=None,describe=None):
        describe = describe
        if class_name:
            class_name = """document.getElementsByClassName("{classname}")
            [{index}].click(); 
            """.format(classname=class_name,index=index)
            d = self.driver.execute_script(class_name)

            return class_name

        if id:

           id =  f"""document.getElementById("{id}").click();"""
           f = self.driver.execute_script(id)
           return name


        if name:
           name =  """document.getElementsByName("{name}")
           [{index}].click();""".format(name=name,index=index)
           return name



    def input(self, id=None,name=None,classname=None, index=None,value=None,describe=None):
        if id:
            id = f"""document.getElementById("{id}").value = "{value}";"""
            self.driver.execute_script(id)
            return id

        describe = describe
        class_name = """document.getElementsByClassName("{classname}")
        ["{index}"].value="{value}"; 
        """.format(classname=classname, index=index,value=value)
        self.driver.execute_script(class_name)

        return class_name

class BrowserObject(object):
    """
    该模类是对javascript 的BOM模型进行封装也就是我们还不能制作一些我们经常看
    到的网页的一些交互，我们需要继续学习BOM和DOM相关知识。
    JavaScript分为 ECMAScript，DOM，BOM。
    BOM（Browser Object Model）是指浏览器对象模型，它使 JavaScript 有能力与
    浏览器进行“对话”。
    """
    #This module class encapsulates the bom model of javascript, that is, we
    # can not make some interactions of the web pages we often see, and we
    # need to continue to learn bom and dom related knowledge. Javascript is
    # divided into ecmascript,dom,bom. Bom (browser object model) refers to
    # the browser object model, which enables javascript to have a "dialogue"
    # with the browser

    def __init__(self,driver):
        self.driver = driver


    def window_Height(self,describe=None):
        describe = describe
        win = """var name = window.innerHeight;
                    console.log(name)"""
        win_height = self.driver.execute_script(win)
        return win_height

    def window_Open(self,describe=None):
        describe = describe
        win = "window.open();"
        win_Open = self.driver.execute_script(win)
        return win_Open

    def window_Close(self,describe=None):
        describe = describe
        win = "window.close();"
        win_close= self.driver.execute_script(win)
        return win_close

    def add_element(self,type=None,tag_name=None,index=None,types=None,
                    values=None,describe=None):
        if tag_name:
            describe = describe
            win = """document.getElementsByTagName
            ("{tagname}")[{indexs}].setAttribute("{types}","{value}");
            """.format(tagname=tag_name,indexs=index,types=types,value=values)
            win_close= self.driver.execute_script(win)

            return win_close




import json



class Cookies(pageElement):

    def get_cookies(self,url=None,path=None,timeout=20):
        self.driver.set_page_load_timeout(timeout)#限制页面加载时间
        self.driver.set_script_timeout(timeout)#限制JavaScript加载时间
        try:
            self.driver.get(url)
        except:
            self.driver.execute_script("window.stop()")
        time.sleep(5)
        input("请登录后按Enter")
        cookies = self.driver.get_cookies()
        print("cookies",cookies)
        jsonCookies = json.dumps(cookies)

        if path:
            path_file = path
        else:
            path_file = "cookies.txt"

        with open(path_file,"w",encoding="utf-8") as f:
            f.write(jsonCookies)
        time.sleep(5)
        self.driver.quit()

    def cookie_login(self,path,url=None,timeout=20):
        self.driver.set_page_load_timeout(timeout)  # 限制页面加载时间
        self.driver.set_script_timeout(timeout)  # 限制JavaScript加载时间
        try:
            self.driver.get(url)
        except:            self.driver.execute_script("window.stop()")
        f1 = open(path)
        cookies = f1.read()
        cookies = json.loads(cookies)
        for co in cookies:
            self.driver.add_cookie(co)
        self.driver.refresh()







if __name__ == '__main__':
    import time

    from selenium import webdriver
    from src.tank.core.webui.base import pageElement

    # from selenium.webdriver.common.keys import Keys
    # dr = webdriver.Chrome()
    dr.get("https://www.baidu.com/")
    c = Cookies()
    c.get_cookies(url='https://www.baidu.com/')
    c.cookie_login(url='https://www.baidu.com/',path="1.txt")

    # dr.find_element_by_id("kw").send_keys("666")
    # web = webdriver.Chrome()
    # c = Cookies(driver=web)


    
    # # c.get_cookies(url=url)
    # c.cookie_login(url=url,path="cookies.txt")

    # page = WebKeys(path='https://www.baidu.com/')
    # page.element(by="id",ele="kw").send_keys(6666)
    # js = JSElement(dr)
    # js.input(id="kw",value='666')
    # js = jsc.compile('''function sum(){alert()}''')
    # result = js.call('sum')
    # time.sleep(1)
    # js.click(id="su")
    # dr.execute_script('document.getElementById("su").click();')
    # page.cla(by="id",val='kw')
    # page.skr(by="id",val='kw')
    # time.sleep(2)
    # page.func(f=page.F5,by="id",val='kw')
    # time.sleep(2)

    # Keys_Home = Keys.HOME

    # time.sleep(0.5)
    # time.sleep(0.5)
    # dr.find_element_by_id("kw").send_keys(Keys_Home)
    # time.sleep(0.5)
    # # dr.find_element_by_id("su").click()
    time.sleep(2)
    dr.quit()

