#!/usr/bin/env python
#-*- coding:utf-8 -*-


"""
    测试框架的全局常量配置及配置信息
    version: 1.0.0
"""


import os

import sys
import platform
BASE_DIR = os.path.abspath(os.path.dirname(os.path.dirname(__file__))).replace("\\","/")


# 浏览器驱动配置路径
BROWSER_DRIVER_PATH = r"D:\python3"

# 指定chrome安装路径
BINARY_LOCATION = '/opt/google/chrome/google-chrome'



# linux下的chromedriver 路径
CHROME_DRIVER_BINARY = '/usr/bin/chromedriver' # 指定chrome安装路径


if(platform.system() == 'Linux'):

    BINARY_LOCATION = '/usr/bin/chromedriver'  # 指定chrome浏览器驱动路径


# 错误重跑次数
TEST_CASE_ERROR_RETRY = 2


import datetime

# 项目根目录
#
# # 测试用例集路径
# CASE_FILE_PATH = os.path.join(BASE,"case").replace("\\",'/')
#
# # 测试报告存放路径
# TEST_REPORT_PATH = os.path.join(BASE,'report').replace("\\",'/')
#
# # 测试用例标注结果路径
# IMAGES_EXCEL_PATH = os.path.join(BASE,'data/result.xlsx').replace("\\",'/')
#
#
#错误截图
SCREENSHOTS_STATE = True


# 本地测试
DEBUG = True

# #测试用例场景路径
# TEST_CASE_FILE_PATH =  os.path.join(BASE,'data/case.xlsx').replace("\\",'/')
#
# # 定义日志文件的路径
# LOG_PATH = os.path.join(BASE,'report/logs').replace('\\','/')
#
# #测试结果
# TEST_CASE_RUN_REPORT = os.path.join(BASE,'report/html').replace('\\','/')
#
# # 测试报告压缩存放目录
# TEST_REPORT_ZIP_FILE_PATH = os.path.join(BASE,'report/zip').replace("\\",'/')
#
# # Test report compressed storage directory
# # 测试报告压缩的文件存放路径
# TEST_REPORT_COMPRESSED_STORAGE = None
#
# # 测试报告压缩存放目录
# TEST_REPORT_IMG_CASE_FILE_PATH = os.path.join(BASE,'report/img').replace("\\",'/')
#
# # Abnormal screenshot
# # 异常截图存放路径



# LOGGING_CONFIG = getattr(settings,'LOG_FILE_PATH')


# 日志路徑
LOG_FILE_PATH = {
    'context_processors':{
        'debug':os.path.join(BASE_DIR,'report/logs')
    }

}

#测试结果
# TEST_CASE_RUN_REPORT = []

# 测试报告
TEST_REPORT = {
    'context_processors':{}
}


# # 识别图片集
# TEST_IMG_FILE_PATH = []


default_log_file = os.path.join(BASE_DIR,'report/logs')


# 运行测试时的匹配表达式
RUN_PATTERN_CASE = "tk_*.py"



# # 测试用例集路径
CASE_SUITE_PATH = os.path.join(BASE_DIR,"case").replace("\\",'/')

# ML_HTML_REPORT_STATUS = True

# 接受邮件报告的邮箱
EMAIL_LISTS = []

# 自动邮箱状态
AUTO_SEND_EMAIL = True

# 邮件发送人
EMAIL_SENDER = {"context_processors":{

}}

# 数据库配置
DATABASE = {
    "default":{
        # 会自动进行联想python 包
        "BACKEND":"redis",
        "LOCATION":"127.0.0.1:6379",
        "OPTIONS":{
            "PASSWORD":"",
            "DB":0
        }
    }
}




# 日志状态
LOGGING_STATUS = False

# 测试执行环境
TEST_RUN_ENV = "sit"

# api模板服务
API_TEST_TEMPLATE = True

# web前端模拟
WEB_TEMPLATE = False

LOG_FORMAT = [

]


