#!/usr/bin/env python
#-*- coding:utf-8 -*-

# authors:guanfl
# 2021/5/20



import os
import importlib
from tank.default.conf import global_settings


class Settings():
    # 初始化项目配置信息
    def __init__(self):
        # 遍历默认的配置文件，并将配置信息添加到，配置对象当中
        for setting in dir(global_settings):
            # 判断是否是大写
            if setting.isupper():
                # 通过反射添加值
                setattr(self, setting, getattr(global_settings, setting))

            # 获取用户的模块字符串
        mod = os.environ.get('settings')
        # importlib可以通过字符串进行导入模块
        module = importlib.import_module(mod)

        # 遍历用户配置文件，并将配置信息添加到对象中，如果重复会覆盖之前系统的配置信息
        for setting in dir(module):
            if setting.isupper():
                setattr(self, setting, getattr(module, setting))


settings = Settings()


# class LazySettings(LazyObject):
#     """
#     全局Django设置或自定义设置对象的惰性代理。
#     用户可以在使用之前手动配置设置。 除此以外，Django使用DJANGO_SETTINGS_MODULE指向的设置模块。
#     """
#
#     def _setup(self, name=None):
#         """
#         加载环境变量指向的设置模块。 这个如果用户尚未使用，则在第一次需要设置时使用手动配置的设置。
#         """
#         # 这个是获取我们manager.py里的os.environ.setdefault("DJANGO_SETTINGS_MODULE", "project.settings")
#         settings_module = os.environ.get(ENVIRONMENT_VARIABLE)
#         if not settings_module:
#             # 如果没有则抛出异常
#             pass
#
#         self._wrapped = Settings(settings_module)
#
#     def __getattr__(self, name):
#         # 返回设置的值并将其缓存在self .__ dict__
#         if self._wrapped is empty:
#             self._setup(name)
#         val = getattr(self._wrapped, name)
#         self.__dict__[name] = val
#         return val
#
#     def __setattr__(self, name, value):
#         """
#         设置设置值。 如果_wrapped发生更改，则清除所有缓存的值（@override_settings执行此操作），或者在设置时清除单个值
#         """
#         if name == '_wrapped':
#             self.__dict__.clear()
#         else:
#             self.__dict__.pop(name, None)
#         super().__setattr__(name, value)
#
#     def __delattr__(self, name):
#         """
#         删除设置并根据需要从缓存中清除它。
#         """
#         super().__delattr__(name)
#         self.__dict__.pop(name, None)
#
#     # 其他方法
#

# class LazyProxy:
#     def __init__(self, cls, *args, **kwargs):
#         print("INIT PROXY")
#         self.__dict__['_cls'] = cls
#         self.__dict__['_params'] = args
#         self.__dict__['_kwargs'] = kwargs
#         self.__dict__['_obj'] = None
#
#     def __getattr__(self, item):
#         if self.__dict__['_obj'] is None:
#             self._init_obj()
#         return getattr(self.__dict__['_obj'], item)
#
#     def __setattr__(self, key, value):
#         if self.__dict__['_obj'] is None:
#             self._init_obj()
#
#         setattr(self.__dict__['_obj'], key, value)
#
#     def _init_obj(self):
#         self.__dict__['_obj'] = object.__new__(self.__dict__['_cls'])
#         self.__dict__['_obj'].__init__(*self.__dict__['_params'], **self.__dict__['_kwargs'])
#
#
# class LazyInit:
#     def __new__(cls, *args, **kwargs):
#         return LazyProxy(cls, *args, **kwargs)
#
#
# class A(LazyInit):
#     def __init__(self, x):
#         print("Init A")
#         self.x = x
#
#
#


