

__all__ = ['TestResult', 'TestCase', 'TestSuite',
           'TextTestRunner', 'TestLoader', 'FunctionTestCase', 'main',
           'defaultTestLoader', 'SkipTest', 'on_run', 'on_run_true', 'on_less_true',
           'expectedFailure', 'TextTestResult', 'installHandler',
           'registerResult', 'removeResult', 'removeHandler',
           'addModuleCleanup']

# Expose obsolete functions for backwards compatibility
__all__.extend(['getTestCaseNames', 'makeSuite', 'findTestCases'])

__tkunit = True

from .result import TestResult
from .case import (addModuleCleanup, TestCase, FunctionTestCase, SkipTest, on_run,
                   on_run_true, on_less_true, expectedFailure)
from .suite import BaseTestSuite, TestSuite
from .loader import (TestLoader, defaultTestLoader, makeSuite, getTestCaseNames,
                     findTestCases)
from .main import TestProgram, main
from .runner import TextTestRunner, TextTestResult
from .sig.signals import installHandler, registerResult, removeResult, removeHandler
# IsolatedAsyncioTestCase将被惰性导入。

# deprecated
_TextTestResult = TextTestResult

#这里没有测试，所以不要尝试运行所发现的任何内容
#内省符号(例如FunctionTestCase)。相反,我们所有的
# test来自unittest.test。
def load_tests(loader, tests, pattern):
    import os.path
    # 在加载器实例上缓存的顶级目录
    this_dir = os.path.dirname(__file__)
    return loader.discover(start_dir=this_dir, pattern=pattern)


#它导入asyncio，相对沉重，但大多数测试
#不需要它。

def __dir__():
    return globals().keys() | {'IsolatedAsyncioTestCase'}

# def __getattr__(name):
#     if name == 'IsolatedAsyncioTestCase':
#         global IsolatedAsyncioTestCase
#         from .async_case import IsolatedAsyncioTestCase
#         return IsolatedAsyncioTestCase
#     raise AttributeError(f"module {__name__!r} has no attribute {name!r}")
